#
# Copyright 2011 by Object Craft P/L, Melbourne, Australia.
#
# LICENCE - see LICENCE file distributed with this software for details.
#

import sys
import os
import optparse

from albatross.cmdline.common import *

def help(cmd):
    try:
        module = __import__('albatross.cmdline.' + cmd, None, None, 
                            ['main', 'usage'])
    except ImportError:
        sys.exit('Unknown cmd %r' % cmd)
    try:
        module.main
        module.usage
    except AttributeError:
        pass
    else:
        if module.usage:
            print module.usage.replace('%prog', ourname) 
        else:
            print '%s %s' % (ourname, cmd)

usage = '''%prog help
        This help text'''

def main(args):
    optp = optparse.OptionParser(usage=usage)
    options, args = optp.parse_args(args)
    if not args:
        args = [name[:-3] for name in os.listdir(os.path.dirname(__file__))
                if name.endswith('.py') and not name.startswith('.')]
        args.sort()
    print 'usage: %s <action> [args]\n\nActions are:\n' % ourname
    for arg in args:
        help(arg)
    print '\nUse "%s help <action>" for detailed information on an action' % ourname
