#!/usr/bin/env python
from albatross.configapp import AppConfig
from albatross.ext import form


cfg = AppConfig('app.ini')

app_cls, ctx_cls = cfg.get_app_classes()

class Context(ctx_cls):

    def __init__(self, app):
        self.cfg = cfg
        ctx_cls.__init__(self, app)

    def static_path(self, *parts):
        return '/'.join((cfg.static_path,)+parts)


class Application(app_cls):

    def __init__(self):
        app_cls.__init__(self, **cfg.get_app_args())
        self.set_logger(cfg.get_logger())
        self.cfg = cfg

    def create_context(self):
        return Context(self)


app = Application()
app.register_tagclasses(*form.tag_classes)      # enable "form" extension
app.load_template('macros.html')                # load page header/footer macros


# Import appropriate Request class for deployment scheme
from albatross.fcgiapp import Request, running

def main():
    while running():
        app.run(Request())


if __name__ == '__main__':
    main()
