from albatross.ext.form import *


class HelloForm(FieldsetForm):

    def __init__(self):
        elements = Fieldset((
                LabelFieldRow(TextField('Firstname', 'firstname',
                                        required=True)),
                LabelFieldRow(TextField('Lastname', 'lastname')),))
        buttons = Buttons((Button('OK', 'ok'),))
        FieldsetForm.__init__(self, 'Who are you?',
                              (elements,), buttons=buttons)


def page_enter(ctx):
    if not ctx.has_value('hello_form'):
        ctx.locals.hello_form = HelloForm()
        ctx.add_session_vars('hello_form')


def page_process(ctx):
    if ctx.req_equals('ok'):
        try:
            ctx.locals.hello_form.validate()
        except FormValidationError:
            return
        model = FormModel()
        ctx.locals.hello_form.merge(model)
        ctx.locals.msg = 'Hello, %s %s!' % (model.firstname,
                                            model.lastname)


def page_display(ctx):
    ctx.run_template('hello.html')
